var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { ref, isRef, toRefs as toRefs$1, customRef, getCurrentScope, onScopeDispose, getCurrentInstance, onMounted, nextTick, unref, computed, reactive, shallowRef, watch, defineComponent, withDirectives, openBlock, createElementBlock, normalizeStyle, normalizeClass, createElementVNode, toDisplayString, withModifiers, mergeProps, vShow, createCommentVNode } from "vue";
var index = "";
let text = ref("");
let open = ref(false);
function useQuickNotes() {
  return { text, open };
}
function tryOnScopeDispose(fn) {
  if (getCurrentScope()) {
    onScopeDispose(fn);
    return true;
  }
  return false;
}
const isClient = typeof window !== "undefined";
const isString = (val) => typeof val === "string";
const noop = () => {
};
var __defProp$6 = Object.defineProperty;
var __defProps$4$1 = Object.defineProperties;
var __getOwnPropDescs$4$1 = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols$8 = Object.getOwnPropertySymbols;
var __hasOwnProp$8 = Object.prototype.hasOwnProperty;
var __propIsEnum$8 = Object.prototype.propertyIsEnumerable;
var __defNormalProp$6 = (obj, key, value) => key in obj ? __defProp$6(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues$6 = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp$8.call(b, prop))
      __defNormalProp$6(a, prop, b[prop]);
  if (__getOwnPropSymbols$8)
    for (var prop of __getOwnPropSymbols$8(b)) {
      if (__propIsEnum$8.call(b, prop))
        __defNormalProp$6(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps$4$1 = (a, b) => __defProps$4$1(a, __getOwnPropDescs$4$1(b));
function toRefs(objectRef) {
  if (!isRef(objectRef))
    return toRefs$1(objectRef);
  const result = Array.isArray(objectRef.value) ? new Array(objectRef.value.length) : {};
  for (const key in objectRef.value) {
    result[key] = customRef(() => ({
      get() {
        return objectRef.value[key];
      },
      set(v) {
        if (Array.isArray(objectRef.value)) {
          const copy = [...objectRef.value];
          copy[key] = v;
          objectRef.value = copy;
        } else {
          objectRef.value = __spreadProps$4$1(__spreadValues$6({}, objectRef.value), { [key]: v });
        }
      }
    }));
  }
  return result;
}
function tryOnMounted(fn, sync = true) {
  if (getCurrentInstance())
    onMounted(fn);
  else if (sync)
    fn();
  else
    nextTick(fn);
}
function useTimeoutFn(cb, interval, options = {}) {
  const {
    immediate = true
  } = options;
  const isPending = ref(false);
  let timer = null;
  function clear() {
    if (timer) {
      clearTimeout(timer);
      timer = null;
    }
  }
  function stop() {
    isPending.value = false;
    clear();
  }
  function start(...args) {
    clear();
    isPending.value = true;
    timer = setTimeout(() => {
      isPending.value = false;
      timer = null;
      cb(...args);
    }, unref(interval));
  }
  if (immediate) {
    isPending.value = true;
    if (isClient)
      start();
  }
  tryOnScopeDispose(stop);
  return {
    isPending,
    start,
    stop
  };
}
function unrefElement(elRef) {
  var _a2;
  const plain = unref(elRef);
  return (_a2 = plain == null ? void 0 : plain.$el) != null ? _a2 : plain;
}
const defaultWindow = isClient ? window : void 0;
const defaultNavigator = isClient ? window.navigator : void 0;
function useEventListener(...args) {
  let target;
  let event;
  let listener;
  let options;
  if (isString(args[0])) {
    [event, listener, options] = args;
    target = defaultWindow;
  } else {
    [target, event, listener, options] = args;
  }
  if (!target)
    return noop;
  let cleanup = noop;
  const stopWatch = watch(() => unrefElement(target), (el) => {
    cleanup();
    if (!el)
      return;
    el.addEventListener(event, listener, options);
    cleanup = () => {
      el.removeEventListener(event, listener, options);
      cleanup = noop;
    };
  }, { immediate: true, flush: "post" });
  const stop = () => {
    stopWatch();
    cleanup();
  };
  tryOnScopeDispose(stop);
  return stop;
}
function useClipboard(options = {}) {
  const {
    navigator = defaultNavigator,
    read = false,
    source,
    copiedDuring = 1500
  } = options;
  const events = ["copy", "cut"];
  const isSupported = Boolean(navigator && "clipboard" in navigator);
  const text2 = ref("");
  const copied = ref(false);
  const timeout = useTimeoutFn(() => copied.value = false, copiedDuring);
  function updateText() {
    navigator.clipboard.readText().then((value) => {
      text2.value = value;
    });
  }
  if (isSupported && read) {
    for (const event of events)
      useEventListener(event, updateText);
  }
  async function copy(value = unref(source)) {
    if (isSupported && value != null) {
      await navigator.clipboard.writeText(value);
      text2.value = value;
      copied.value = true;
      timeout.start();
    }
  }
  return {
    isSupported,
    text: text2,
    copied,
    copy
  };
}
const _global = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
const globalKey = "__vueuse_ssr_handlers__";
_global[globalKey] = _global[globalKey] || {};
_global[globalKey];
var __defProp$b = Object.defineProperty;
var __defProps$4 = Object.defineProperties;
var __getOwnPropDescs$4 = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols$d = Object.getOwnPropertySymbols;
var __hasOwnProp$d = Object.prototype.hasOwnProperty;
var __propIsEnum$d = Object.prototype.propertyIsEnumerable;
var __defNormalProp$b = (obj, key, value) => key in obj ? __defProp$b(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues$b = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp$d.call(b, prop))
      __defNormalProp$b(a, prop, b[prop]);
  if (__getOwnPropSymbols$d)
    for (var prop of __getOwnPropSymbols$d(b)) {
      if (__propIsEnum$d.call(b, prop))
        __defNormalProp$b(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps$4 = (a, b) => __defProps$4(a, __getOwnPropDescs$4(b));
function useDraggable(target, options = {}) {
  var _a2, _b2;
  const draggingElement = (_a2 = options.draggingElement) != null ? _a2 : defaultWindow;
  const position = ref((_b2 = options.initialValue) != null ? _b2 : { x: 0, y: 0 });
  const pressedDelta = ref();
  const filterEvent = (e) => {
    if (options.pointerTypes)
      return options.pointerTypes.includes(e.pointerType);
    return true;
  };
  const handleEvent = (e) => {
    if (unref(options.preventDefault))
      e.preventDefault();
    if (unref(options.stopPropagation))
      e.stopPropagation();
  };
  const start = (e) => {
    var _a22;
    if (!filterEvent(e))
      return;
    if (unref(options.exact) && e.target !== unref(target))
      return;
    const rect = unref(target).getBoundingClientRect();
    const pos = {
      x: e.pageX - rect.left,
      y: e.pageY - rect.top
    };
    if (((_a22 = options.onStart) == null ? void 0 : _a22.call(options, pos, e)) === false)
      return;
    pressedDelta.value = pos;
    handleEvent(e);
  };
  const move = (e) => {
    var _a22;
    if (!filterEvent(e))
      return;
    if (!pressedDelta.value)
      return;
    position.value = {
      x: e.pageX - pressedDelta.value.x,
      y: e.pageY - pressedDelta.value.y
    };
    (_a22 = options.onMove) == null ? void 0 : _a22.call(options, position.value, e);
    handleEvent(e);
  };
  const end = (e) => {
    var _a22;
    if (!filterEvent(e))
      return;
    if (!pressedDelta.value)
      return;
    pressedDelta.value = void 0;
    (_a22 = options.onEnd) == null ? void 0 : _a22.call(options, position.value, e);
    handleEvent(e);
  };
  if (isClient) {
    useEventListener(target, "pointerdown", start, true);
    useEventListener(draggingElement, "pointermove", move, true);
    useEventListener(draggingElement, "pointerup", end, true);
  }
  return __spreadProps$4(__spreadValues$b({}, toRefs(position)), {
    position,
    isDragging: computed(() => !!pressedDelta.value),
    style: computed(() => `left:${position.value.x}px;top:${position.value.y}px;`)
  });
}
const DefaultMagicKeysAliasMap = {
  ctrl: "control",
  command: "meta",
  cmd: "meta",
  option: "alt",
  up: "arrowup",
  down: "arrowdown",
  left: "arrowleft",
  right: "arrowright"
};
function useMagicKeys(options = {}) {
  const {
    reactive: useReactive = false,
    target = defaultWindow,
    aliasMap = DefaultMagicKeysAliasMap,
    passive = true,
    onEventFired = noop
  } = options;
  const current = reactive(/* @__PURE__ */ new Set());
  const obj = { toJSON() {
    return {};
  }, current };
  const refs = useReactive ? reactive(obj) : obj;
  const metaDeps = /* @__PURE__ */ new Set();
  function setRefs(key, value) {
    if (key in refs) {
      if (useReactive)
        refs[key] = value;
      else
        refs[key].value = value;
    }
  }
  function updateRefs(e, value) {
    var _a2, _b2;
    const key = (_a2 = e.key) == null ? void 0 : _a2.toLowerCase();
    const code = (_b2 = e.code) == null ? void 0 : _b2.toLowerCase();
    const values = [code, key].filter(Boolean);
    if (code) {
      if (value)
        current.add(e.code);
      else
        current.delete(e.code);
    }
    for (const key2 of values)
      setRefs(key2, value);
    if (key === "meta" && !value) {
      metaDeps.forEach((key2) => {
        current.delete(key2);
        setRefs(key2, false);
      });
      metaDeps.clear();
    } else if (e.getModifierState("Meta") && value) {
      [...current, ...values].forEach((key2) => metaDeps.add(key2));
    }
  }
  if (target) {
    useEventListener(target, "keydown", (e) => {
      updateRefs(e, true);
      return onEventFired(e);
    }, { passive });
    useEventListener(target, "keyup", (e) => {
      updateRefs(e, false);
      return onEventFired(e);
    }, { passive });
  }
  const proxy = new Proxy(refs, {
    get(target2, prop, rec) {
      if (typeof prop !== "string")
        return Reflect.get(target2, prop, rec);
      prop = prop.toLowerCase();
      if (prop in aliasMap)
        prop = aliasMap[prop];
      if (!(prop in refs)) {
        if (/[+_-]/.test(prop)) {
          const keys = prop.split(/[+_-]/g).map((i) => i.trim());
          refs[prop] = computed(() => keys.every((key) => unref(proxy[key])));
        } else {
          refs[prop] = ref(false);
        }
      }
      const r = Reflect.get(target2, prop, rec);
      return useReactive ? unref(r) : r;
    }
  });
  return proxy;
}
var _a, _b;
isClient && (window == null ? void 0 : window.navigator) && ((_a = window == null ? void 0 : window.navigator) == null ? void 0 : _a.platform) && /iP(ad|hone|od)/.test((_b = window == null ? void 0 : window.navigator) == null ? void 0 : _b.platform);
function useSpeechRecognition(options = {}) {
  const {
    interimResults = true,
    continuous = true,
    window: window2 = defaultWindow
  } = options;
  const lang = ref(options.lang || "en-US");
  const isListening = ref(false);
  const isFinal = ref(false);
  const result = ref("");
  const error = shallowRef(void 0);
  const toggle = (value = !isListening.value) => {
    isListening.value = value;
  };
  const start = () => {
    isListening.value = true;
  };
  const stop = () => {
    isListening.value = false;
  };
  const SpeechRecognition = window2 && (window2.SpeechRecognition || window2.webkitSpeechRecognition);
  const isSupported = Boolean(SpeechRecognition);
  let recognition;
  if (isSupported) {
    recognition = new SpeechRecognition();
    recognition.continuous = continuous;
    recognition.interimResults = interimResults;
    recognition.lang = unref(lang);
    recognition.onstart = () => {
      isFinal.value = false;
    };
    watch(lang, (lang2) => {
      if (recognition && !isListening.value)
        recognition.lang = lang2;
    });
    recognition.onresult = (event) => {
      const transcript = Array.from(event.results).map((result2) => {
        isFinal.value = result2.isFinal;
        return result2[0];
      }).map((result2) => result2.transcript).join("");
      result.value = transcript;
      error.value = void 0;
    };
    recognition.onerror = (event) => {
      error.value = event;
    };
    recognition.onend = () => {
      isListening.value = false;
      recognition.lang = unref(lang);
    };
    watch(isListening, () => {
      if (isListening.value)
        recognition.start();
      else
        recognition.stop();
    });
  }
  tryOnScopeDispose(() => {
    isListening.value = false;
  });
  return {
    isSupported,
    isListening,
    isFinal,
    recognition,
    result,
    error,
    toggle,
    start,
    stop
  };
}
function useWindowSize({ window: window2 = defaultWindow, initialWidth = Infinity, initialHeight = Infinity } = {}) {
  const width = ref(initialWidth);
  const height = ref(initialHeight);
  const update = () => {
    if (window2) {
      width.value = window2.innerWidth;
      height.value = window2.innerHeight;
    }
  };
  update();
  tryOnMounted(update);
  useEventListener("resize", update, { passive: true });
  return { width, height };
}
const _hoisted_1 = ["for"];
const _hoisted_2 = { class: "flex space-x-2" };
const _hoisted_3 = /* @__PURE__ */ createElementVNode("path", {
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  d: "M8 5H6a2 2 0 00-2 2v12a2 2 0 002 2h10a2 2 0 002-2v-1M8 5a2 2 0 002 2h2a2 2 0 002-2M8 5a2 2 0 012-2h2a2 2 0 012 2m0 0h2a2 2 0 012 2v3m2 4H10m0 0l3-3m-3 3l3 3"
}, null, -1);
const _hoisted_4 = [
  _hoisted_3
];
const _hoisted_5 = /* @__PURE__ */ createElementVNode("path", {
  "fill-rule": "evenodd",
  d: "M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z",
  "clip-rule": "evenodd"
}, null, -1);
const _hoisted_6 = [
  _hoisted_5
];
const _hoisted_7 = ["id", "value", "rows"];
const _hoisted_8 = {
  xmlns: "http://www.w3.org/2000/svg",
  class: "h-4 w-4",
  fill: "none",
  viewBox: "0 0 24 24",
  stroke: "currentColor",
  "stroke-width": "2"
};
const _hoisted_9 = /* @__PURE__ */ createElementVNode("path", {
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  d: "M19 11a7 7 0 01-7 7m0 0a7 7 0 01-7-7m7 7v4m0 0H8m4 0h4m-4-8a3 3 0 01-3-3V5a3 3 0 116 0v6a3 3 0 01-3 3z"
}, null, -1);
const _hoisted_10 = [
  _hoisted_9
];
const _hoisted_11 = {
  xmlns: "http://www.w3.org/2000/svg",
  class: "h-4 w-4",
  viewBox: "0 0 20 20",
  fill: "currentColor"
};
const _hoisted_12 = /* @__PURE__ */ createElementVNode("path", {
  "fill-rule": "evenodd",
  d: "M10 18a8 8 0 100-16 8 8 0 000 16zM8 7a1 1 0 00-1 1v4a1 1 0 001 1h4a1 1 0 001-1V8a1 1 0 00-1-1H8z",
  "clip-rule": "evenodd"
}, null, -1);
const _hoisted_13 = [
  _hoisted_12
];
const _hoisted_14 = {
  key: 0,
  class: "text-red-500 text-sm"
};
const _hoisted_15 = {
  key: 1,
  class: "text-red-500 text-sm"
};
const _hoisted_16 = {
  key: 2,
  class: "text-green-500 text-sm"
};
const _hoisted_17 = {
  key: 3,
  class: "text-red-500 text-sm"
};
const __default__ = {
  inheritAttrs: false
};
const _sfc_main = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: {
    x: Number,
    y: Number,
    modelValue: {
      type: String,
      default: ""
    },
    label: String,
    zIndex: {
      type: String,
      default: "20"
    },
    lang: {
      type: String,
      default: "en-US"
    },
    parentClass: String,
    buttonClass: String,
    rows: {
      type: String,
      default: "5"
    }
  },
  emits: ["update:modelValue"],
  setup(__props, { emit }) {
    const props = __props;
    let { text: text2, open: open2 } = useQuickNotes();
    onMounted(() => {
      text2.value = props.modelValue;
    });
    const dragger = ref(null);
    const _position = computed(() => {
      let _x = width.value - 350;
      let _y = height.value - 250;
      return {
        x: props.x ? props.x : _x,
        y: props.y ? props.y : _y
      };
    });
    const _source = ref(props.modelValue);
    const { width, height } = useWindowSize();
    const { style } = useDraggable(dragger, {
      initialValue: { x: _position.value.x, y: _position.value.y },
      preventDefault: true
    });
    const { ctrl_alt_k } = useMagicKeys();
    const {
      copy,
      copied,
      isSupported: cIsSupported
    } = useClipboard({
      source: _source
    });
    const { isListening, start, stop, result, isSupported, error } = useSpeechRecognition({
      lang: props.lang,
      interimResults: false,
      continuous: false
    });
    let _style = computed(() => {
      return `${style.value}  z-index:${props.zIndex};`;
    });
    let _id = computed(() => {
      return Math.random().toString(36).substring(7);
    });
    const handleInput = (e) => {
      const v = e.target.value;
      _source.value = v;
      emitInput(v);
    };
    const emitInput = (v) => {
      text2.value = v;
      emit("update:modelValue", v);
    };
    if (isSupported)
      watch(result, (v) => {
        _source.value += (_source.value == "" ? "" : " ") + v;
        emitInput(_source.value);
      });
    watch(ctrl_alt_k, (v) => {
      if (v)
        open2.value = true;
    });
    return (_ctx, _cache) => {
      return withDirectives((openBlock(), createElementBlock("div", {
        ref: "parent",
        style: normalizeStyle([unref(_style), { "min-height": "40px", "min-width": "300px" }]),
        class: normalizeClass([__props.parentClass, "fixed rounded-md shadow-md p-3 space-y-2"])
      }, [
        createElementVNode("div", {
          ref_key: "dragger",
          ref: dragger,
          class: "flex items-center justify-between cursor-grab"
        }, [
          createElementVNode("label", {
            for: unref(_id),
            class: "font-medium"
          }, toDisplayString(__props.label), 9, _hoisted_1),
          createElementVNode("div", _hoisted_2, [
            (openBlock(), createElementBlock("svg", {
              onClick: _cache[0] || (_cache[0] = withModifiers(($event) => unref(copy)(), ["stop"])),
              xmlns: "http://www.w3.org/2000/svg",
              class: "h-4 w-4 cursor-pointer",
              fill: "none",
              viewBox: "0 0 24 24",
              stroke: "currentColor",
              "stroke-width": "2"
            }, _hoisted_4)),
            (openBlock(), createElementBlock("svg", {
              onClick: _cache[1] || (_cache[1] = withModifiers(($event) => isRef(open2) ? open2.value = !unref(open2) : open2 = !unref(open2), ["stop"])),
              xmlns: "http://www.w3.org/2000/svg",
              class: "h-4 w-4 cursor-pointer",
              viewBox: "0 0 20 20",
              fill: "currentColor"
            }, _hoisted_6))
          ])
        ], 512),
        createElementVNode("textarea", mergeProps({ id: unref(_id) }, _ctx.$attrs, {
          type: "text",
          value: _source.value,
          onInput: handleInput,
          rows: __props.rows,
          class: "form-textarea w-full h-full rounded-md focus:outline-none border border-blue-200"
        }), null, 16, _hoisted_7),
        createElementVNode("button", {
          onClick: _cache[2] || (_cache[2] = ($event) => unref(isListening) ? unref(stop)() : unref(start)()),
          class: normalizeClass([[
            unref(isListening) ? "animate-bounce" : "",
            !unref(cIsSupported) || !unref(isSupported) || unref(copied) || unref(error) ? "bottom-14" : "",
            __props.buttonClass
          ], "absolute bottom-7 right-6 rounded-full p-2 cursor-pointer bg-blue-500 text-white"])
        }, [
          withDirectives((openBlock(), createElementBlock("svg", _hoisted_8, _hoisted_10, 512)), [
            [vShow, !unref(isListening)]
          ]),
          withDirectives((openBlock(), createElementBlock("svg", _hoisted_11, _hoisted_13, 512)), [
            [vShow, unref(isListening)]
          ])
        ], 2),
        !unref(cIsSupported) ? (openBlock(), createElementBlock("div", _hoisted_14, " Clipboard Coping not supported or permission denid ")) : createCommentVNode("", true),
        !unref(isSupported) ? (openBlock(), createElementBlock("div", _hoisted_15, " Speech Recognition is not supported or permission denid ")) : createCommentVNode("", true),
        unref(copied) ? (openBlock(), createElementBlock("div", _hoisted_16, " Copied Successfully ")) : createCommentVNode("", true),
        unref(error) ? (openBlock(), createElementBlock("div", _hoisted_17, toDisplayString(unref(error).error + ": " + unref(error).message), 1)) : createCommentVNode("", true)
      ], 6)), [
        [vShow, unref(open2)]
      ]);
    };
  }
}));
export { _sfc_main as VueQuickNotes, useQuickNotes };
